; Begin
	R0L EQU 0xC
	R0H EQU 0xD
	R1L EQU 0xE
	R1H EQU 0xF
	R2L EQU 0x10
	R2H EQU 0x11
	R3L EQU 0x12
	R3H EQU 0x13
	R4L EQU 0x14
	R4H EQU 0x15
	R5L EQU 0x16
	R5H EQU 0x17
	ORG 0x0000
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0012
	ORG 0x0004
	RETFIE
L0012:
; 1:  'initialisation
; 2: TRISA = 0
	BSF STATUS,RP0
	CLRF 0x05
	BCF STATUS,RP0
; 3: TRISB = 0
	BSF STATUS,RP0
	CLRF 0x06
	BCF STATUS,RP0
; 4: PORTA = 0
	CLRF 0x05
; 5: PORTB = 0
	CLRF 0x06
; 6: Dim temp As Byte
;       The address of 'temp' is 0x19
	temp EQU 0x19
; 7: Dim temp2 As Byte
;       The address of 'temp2' is 0x1A
	temp2 EQU 0x1A
; 8: Dim sign As Byte
;       The address of 'sign' is 0x1B
	sign EQU 0x1B
; 9: Dim temp3 As Byte '*********
;       The address of 'temp3' is 0x1C
	temp3 EQU 0x1C
; 10: Dim dig As Bit
;       The address of 'dig' is 0x18,0
; 11: Dim count As Byte
;       The address of 'count' is 0x1D
	count EQU 0x1D
; 12: Dim termo As Byte
;       The address of 'termo' is 0x1E
	termo EQU 0x1E
; 13: 
; 14: Dim min As Byte
;       The address of 'min' is 0x1F
	min EQU 0x1F
; 15: Dim max As Byte
;       The address of 'max' is 0x20
	max EQU 0x20
; 16: Dim a1 As Byte
;       The address of 'a1' is 0x21
	a1 EQU 0x21
; 17: 
; 18: max = 0
	CLRF 0x20
; 19: min = 255 '*********************
	MOVLW 0xFF
	MOVWF 0x1F
; 20: termo = 100
	MOVLW 0x64
	MOVWF 0x1E
; 21: 
; 22: Define 1WIRE_REG = PORTA
; 23: Define 1WIRE_BIT = 0
; 24:  'LCD initialisation
; 25: Define LCD_BITS = 8
; 26: Define LCD_DREG = PORTB
; 27: Define LCD_DBIT = 0
; 28: Define LCD_RSREG = PORTA
; 29: Define LCD_RSBIT = 1
; 30: Define LCD_EREG = PORTA
; 31: Define LCD_EBIT = 3
; 32: Define LCD_RWREG = 0
; 33: Define LCD_RWBIT = 0
; 34: Lcdinit
	BCF 0x05,3
	BCF 0x05,1
	BSF STATUS,RP0
	BCF 0x05,3
	BCF 0x05,1
	CLRF 0x06
	BCF STATUS,RP0
	MOVLW 0x64
	MOVWF R0L
	MOVLW 0x00
	MOVWF R0H
	CALL W001
	MOVLW 0x33
	CALL LC02
	MOVLW 0x33
	CALL LC02
	MOVLW 0x33
	CALL LC02
	MOVLW 0x38
	CALL LC02
	MOVLW 0x0C
	CALL LC02
	MOVLW 0x01
	CALL LC02
; 35: Gosub time
	CALL L0011
; 36: Gosub time
	CALL L0011
; 37:  'START *******************************************
; 38:  '*************************************************
; 39: 
; 40: Lcdout "  THERMOMETER"
	MOVLW 0x20
	CALL LC01
	MOVLW 0x20
	CALL LC01
	MOVLW 0x54
	CALL LC01
	MOVLW 0x48
	CALL LC01
	MOVLW 0x45
	CALL LC01
	MOVLW 0x52
	CALL LC01
	MOVLW 0x4D
	CALL LC01
	MOVLW 0x4F
	CALL LC01
	MOVLW 0x4D
	CALL LC01
	MOVLW 0x45
	CALL LC01
	MOVLW 0x54
	CALL LC01
	MOVLW 0x45
	CALL LC01
	MOVLW 0x52
	CALL LC01
; 41: Lcdcmdout LcdLine2Home
	MOVLW 0xC0
	CALL LC02
; 42: Lcdout "     v8.0"
	MOVLW 0x20
	CALL LC01
	MOVLW 0x20
	CALL LC01
	MOVLW 0x20
	CALL LC01
	MOVLW 0x20
	CALL LC01
	MOVLW 0x20
	CALL LC01
	MOVLW 0x76
	CALL LC01
	MOVLW 0x38
	CALL LC01
	MOVLW 0x2E
	CALL LC01
	MOVLW 0x30
	CALL LC01
; 43: 
; 44: Gosub measure
	CALL L0007
; 45: 
; 46:  'test thermometer *******************************
; 47: 1wireInit
	CALL WW01
; 48: 1wireSendByte 0x33
	MOVLW 0x33
	CALL WW05
; 49: 1wireGetByte a1
	CALL WW07
	MOVWF 0x21
; 50: If a1 = 0 Or a1 = 255 Then
	MOVF 0x21,W
	SUBLW 0x00
	BTFSS STATUS,Z
	GOTO L0015
	GOTO L0014
L0015:
	MOVLW 0x1F
	ANDWF STATUS,F
	MOVF 0x21,W
	SUBLW 0xFF
	BTFSS STATUS,Z
	GOTO L0013
L0014:
; 51: Lcdcmdout LcdClear
	MOVLW 0x01
	CALL LC02
; 52: Lcdout " DS18S20/DS1820"
	MOVLW 0x20
	CALL LC01
	MOVLW 0x44
	CALL LC01
	MOVLW 0x53
	CALL LC01
	MOVLW 0x31
	CALL LC01
	MOVLW 0x38
	CALL LC01
	MOVLW 0x53
	CALL LC01
	MOVLW 0x32
	CALL LC01
	MOVLW 0x30
	CALL LC01
	MOVLW 0x2F
	CALL LC01
	MOVLW 0x44
	CALL LC01
	MOVLW 0x53
	CALL LC01
	MOVLW 0x31
	CALL LC01
	MOVLW 0x38
	CALL LC01
	MOVLW 0x32
	CALL LC01
	MOVLW 0x30
	CALL LC01
; 53: Lcdcmdout LcdLine2Home
	MOVLW 0xC0
	CALL LC02
; 54: Lcdout "   Not found"
	MOVLW 0x20
	CALL LC01
	MOVLW 0x20
	CALL LC01
	MOVLW 0x20
	CALL LC01
	MOVLW 0x4E
	CALL LC01
	MOVLW 0x6F
	CALL LC01
	MOVLW 0x74
	CALL LC01
	MOVLW 0x20
	CALL LC01
	MOVLW 0x66
	CALL LC01
	MOVLW 0x6F
	CALL LC01
	MOVLW 0x75
	CALL LC01
	MOVLW 0x6E
	CALL LC01
	MOVLW 0x64
	CALL LC01
; 55: Gosub time
	CALL L0011
; 56: Gosub time
	CALL L0011
; 57: Lcdcmdout LcdClear
	MOVLW 0x01
	CALL LC02
; 58: Endif
L0013:	MOVLW 0x1F
	ANDWF STATUS,F
; 59: 
; 60:  'read temperature *******************************
; 61: 
; 62: Read 0, temp3
	MOVLW 0x00
	MOVWF EEADR
	BSF STATUS,RP0
	BSF EECON1,RD
	NOP
	BCF STATUS,RP0
	MOVF EEDATA,W
	MOVWF 0x1C
; 63: If temp3 = 255 Or temp3 = 0 Then temp3 = 100
	MOVF 0x1C,W
	SUBLW 0xFF
	BTFSS STATUS,Z
	GOTO L0018
	GOTO L0017
L0018:
	MOVLW 0x1F
	ANDWF STATUS,F
	MOVF 0x1C,W
	SUBLW 0x00
	BTFSS STATUS,Z
	GOTO L0016
L0017:
	MOVLW 0x64
	MOVWF 0x1C
L0016:	MOVLW 0x1F
	ANDWF STATUS,F
; 64: termo = temp3
	MOVF 0x1C,W
	MOVWF 0x1E
; 65: 
; 66: 
; 67: 
; 68:  '*************************************************
; 69:  '*************************************************
; 70: 
; 71: main: 
L0001:
; 72: 
; 73: Gosub measure
	CALL L0007
; 74: Lcdcmdout LcdClear
	MOVLW 0x01
	CALL LC02
; 75: Lcdout "Temp  "
	MOVLW 0x54
	CALL LC01
	MOVLW 0x65
	CALL LC01
	MOVLW 0x6D
	CALL LC01
	MOVLW 0x70
	CALL LC01
	MOVLW 0x20
	CALL LC01
	MOVLW 0x20
	CALL LC01
; 76: Gosub print
	CALL L0008
; 77: Lcdout " C"
	MOVLW 0x20
	CALL LC01
	MOVLW 0x43
	CALL LC01
; 78: 
; 79:  'Termostat ************************************
; 80: If temp2 > termo Then PORTA.4 = 0
	MOVF 0x1A,W
	SUBWF 0x1E,W
	BTFSC STATUS,C
	GOTO L0019
	BCF 0x05,4
L0019:	MOVLW 0x1F
	ANDWF STATUS,F
; 81: 
; 82: If temp2 < termo Then
	MOVF 0x1E,W
	SUBWF 0x1A,W
	BTFSC STATUS,C
	GOTO L0020
; 83: PORTA.4 = 1
	BSF 0x05,4
; 84: Endif
L0020:	MOVLW 0x1F
	ANDWF STATUS,F
; 85: 
; 86: If PORTA.4 = 1 Then
	BTFSS 0x05,4
	GOTO L0021
; 87: Lcdcmdout LcdLine1Pos(16)
	MOVLW 0x8F
	CALL LC02
; 88: Lcdout "T"
	MOVLW 0x54
	CALL LC01
; 89: Endif
L0021:	MOVLW 0x1F
	ANDWF STATUS,F
; 90: 
; 91: Lcdcmdout LcdLine2Home
	MOVLW 0xC0
	CALL LC02
; 92: 
; 93: If temp2 > max Then max = temp2
	MOVF 0x1A,W
	SUBWF 0x20,W
	BTFSC STATUS,C
	GOTO L0022
	MOVF 0x1A,W
	MOVWF 0x20
L0022:	MOVLW 0x1F
	ANDWF STATUS,F
; 94: If temp2 < min Then min = temp2
	MOVF 0x1F,W
	SUBWF 0x1A,W
	BTFSC STATUS,C
	GOTO L0023
	MOVF 0x1A,W
	MOVWF 0x1F
L0023:	MOVLW 0x1F
	ANDWF STATUS,F
; 95: 
; 96:  'show MIN and MAX   ***************************
; 97: temp3 = min
	MOVF 0x1F,W
	MOVWF 0x1C
; 98: Lcdout "MIN:"
	MOVLW 0x4D
	CALL LC01
	MOVLW 0x49
	CALL LC01
	MOVLW 0x4E
	CALL LC01
	MOVLW 0x3A
	CALL LC01
; 99: Gosub print1
	CALL L0009
; 100: Lcdout " MAX:"
	MOVLW 0x20
	CALL LC01
	MOVLW 0x4D
	CALL LC01
	MOVLW 0x41
	CALL LC01
	MOVLW 0x58
	CALL LC01
	MOVLW 0x3A
	CALL LC01
; 101: temp3 = max
	MOVF 0x20,W
	MOVWF 0x1C
; 102: Gosub print1
	CALL L0009
; 103: count = 0
	CLRF 0x1D
; 104: 
; 105: 
; 106: 
; 107: 
; 108:  'Button ***************************************
; 109: loop1: 
L0002:
; 110: Gosub button
	CALL L0010
; 111: If temp3 = 128 Then Gosub clear
	MOVF 0x1C,W
	SUBLW 0x80
	BTFSS STATUS,Z
	GOTO L0024
	CALL L0003
L0024:	MOVLW 0x1F
	ANDWF STATUS,F
; 112: WaitMs 4
	MOVLW 0x04
	MOVWF R0L
	CLRF R0H
	CALL W001
; 113: count = count + 1
	MOVF 0x1D,W
	ADDLW 0x01
	MOVWF 0x1D
; 114: If count.7 = 1 Then Goto main Else Goto loop1
	BTFSS 0x1D,7
	GOTO L0025
	GOTO L0001
	GOTO L0026
L0025:	MOVLW 0x1F
	ANDWF STATUS,F
	GOTO L0002
L0026:	MOVLW 0x1F
	ANDWF STATUS,F
; 115: 
; 116: Goto main
	GOTO L0001
; 117: 
; 118: End
L0027:	GOTO L0027
; 119: 
; 120:  'SUBS ****************************************
; 121:  '#############################################
; 122: clear: 
L0003:
; 123: Lcdcmdout LcdClear
	MOVLW 0x01
	CALL LC02
; 124: Lcdout "Clear MIN/MAX ?"
	MOVLW 0x43
	CALL LC01
	MOVLW 0x6C
	CALL LC01
	MOVLW 0x65
	CALL LC01
	MOVLW 0x61
	CALL LC01
	MOVLW 0x72
	CALL LC01
	MOVLW 0x20
	CALL LC01
	MOVLW 0x4D
	CALL LC01
	MOVLW 0x49
	CALL LC01
	MOVLW 0x4E
	CALL LC01
	MOVLW 0x2F
	CALL LC01
	MOVLW 0x4D
	CALL LC01
	MOVLW 0x41
	CALL LC01
	MOVLW 0x58
	CALL LC01
	MOVLW 0x20
	CALL LC01
	MOVLW 0x3F
	CALL LC01
; 125: WaitMs 1100 'TO CHANGE !!!!!!!!!!!!!!!!!
	MOVLW 0x4C
	MOVWF R0L
	MOVLW 0x04
	MOVWF R0H
	CALL W001
; 126: label2: 
L0004:
; 127: Gosub button
	CALL L0010
; 128: 
; 129: If temp3 = 128 Then Gosub setup
	MOVF 0x1C,W
	SUBLW 0x80
	BTFSS STATUS,Z
	GOTO L0028
	CALL L0005
L0028:	MOVLW 0x1F
	ANDWF STATUS,F
; 130: If temp3 = 64 Then
	MOVF 0x1C,W
	SUBLW 0x40
	BTFSS STATUS,Z
	GOTO L0029
; 131: Lcdcmdout LcdLine2Home
	MOVLW 0xC0
	CALL LC02
; 132: Lcdout "MIN/MAX cleared"
	MOVLW 0x4D
	CALL LC01
	MOVLW 0x49
	CALL LC01
	MOVLW 0x4E
	CALL LC01
	MOVLW 0x2F
	CALL LC01
	MOVLW 0x4D
	CALL LC01
	MOVLW 0x41
	CALL LC01
	MOVLW 0x58
	CALL LC01
	MOVLW 0x20
	CALL LC01
	MOVLW 0x63
	CALL LC01
	MOVLW 0x6C
	CALL LC01
	MOVLW 0x65
	CALL LC01
	MOVLW 0x61
	CALL LC01
	MOVLW 0x72
	CALL LC01
	MOVLW 0x65
	CALL LC01
	MOVLW 0x64
	CALL LC01
; 133: min = 255
	MOVLW 0xFF
	MOVWF 0x1F
; 134: max = 0
	CLRF 0x20
; 135: Gosub time
	CALL L0011
; 136: Return
	RETURN
; 137: Endif
L0029:	MOVLW 0x1F
	ANDWF STATUS,F
; 138: If temp3 = 0 Then Goto label2
	MOVF 0x1C,W
	SUBLW 0x00
	BTFSS STATUS,Z
	GOTO L0030
	GOTO L0004
L0030:	MOVLW 0x1F
	ANDWF STATUS,F
; 139: Return
	RETURN
; 140: 
; 141: setup: 
L0005:
; 142: Lcdcmdout LcdClear
	MOVLW 0x01
	CALL LC02
; 143: Lcdout "Termostat setup"
	MOVLW 0x54
	CALL LC01
	MOVLW 0x65
	CALL LC01
	MOVLW 0x72
	CALL LC01
	MOVLW 0x6D
	CALL LC01
	MOVLW 0x6F
	CALL LC01
	MOVLW 0x73
	CALL LC01
	MOVLW 0x74
	CALL LC01
	MOVLW 0x61
	CALL LC01
	MOVLW 0x74
	CALL LC01
	MOVLW 0x20
	CALL LC01
	MOVLW 0x73
	CALL LC01
	MOVLW 0x65
	CALL LC01
	MOVLW 0x74
	CALL LC01
	MOVLW 0x75
	CALL LC01
	MOVLW 0x70
	CALL LC01
; 144: 
; 145: Lcdcmdout LcdLine2Clear
	MOVLW 0xC0
	CALL LC02
	MOVLW 0x28
	MOVWF R0L
L0031:	MOVLW 0x20
	CALL LC01
	DECFSZ R0L,F
	GOTO L0031
	MOVLW 0xC0
	CALL LC02
; 146: Lcdcmdout LcdLine2Home
	MOVLW 0xC0
	CALL LC02
; 147: Lcdout "Temp:"
	MOVLW 0x54
	CALL LC01
	MOVLW 0x65
	CALL LC01
	MOVLW 0x6D
	CALL LC01
	MOVLW 0x70
	CALL LC01
	MOVLW 0x3A
	CALL LC01
; 148: temp3 = termo
	MOVF 0x1E,W
	MOVWF 0x1C
; 149: Gosub print1
	CALL L0009
; 150: 
; 151: Gosub time 'TO CHANGE !!!!!!!!!!!!!!!!!
	CALL L0011
; 152: Gosub time
	CALL L0011
; 153: loop4: 
L0006:
; 154: 
; 155: 
; 156: Gosub button
	CALL L0010
; 157: 
; 158: If temp3 = 128 Then
	MOVF 0x1C,W
	SUBLW 0x80
	BTFSS STATUS,Z
	GOTO L0032
; 159: Lcdcmdout LcdClear
	MOVLW 0x01
	CALL LC02
; 160: Lcdout "Wait"
	MOVLW 0x57
	CALL LC01
	MOVLW 0x61
	CALL LC01
	MOVLW 0x69
	CALL LC01
	MOVLW 0x74
	CALL LC01
; 161: Goto main
	GOTO L0001
; 162: Endif
L0032:	MOVLW 0x1F
	ANDWF STATUS,F
; 163: 
; 164: If temp3 = 64 Then termo = termo + 1
	MOVF 0x1C,W
	SUBLW 0x40
	BTFSS STATUS,Z
	GOTO L0033
	MOVF 0x1E,W
	ADDLW 0x01
	MOVWF 0x1E
L0033:	MOVLW 0x1F
	ANDWF STATUS,F
; 165: If temp3 = 32 Then termo = termo - 1
	MOVF 0x1C,W
	SUBLW 0x20
	BTFSS STATUS,Z
	GOTO L0034
	MOVLW 0x01
	SUBWF 0x1E,W
	MOVWF 0x1E
L0034:	MOVLW 0x1F
	ANDWF STATUS,F
; 166: 
; 167: If temp3 = 64 Or temp3 = 32 Then
	MOVF 0x1C,W
	SUBLW 0x40
	BTFSS STATUS,Z
	GOTO L0037
	GOTO L0036
L0037:
	MOVLW 0x1F
	ANDWF STATUS,F
	MOVF 0x1C,W
	SUBLW 0x20
	BTFSS STATUS,Z
	GOTO L0035
L0036:
; 168: Lcdcmdout LcdLine2Clear
	MOVLW 0xC0
	CALL LC02
	MOVLW 0x28
	MOVWF R0L
L0038:	MOVLW 0x20
	CALL LC01
	DECFSZ R0L,F
	GOTO L0038
	MOVLW 0xC0
	CALL LC02
; 169: Lcdcmdout LcdLine2Home
	MOVLW 0xC0
	CALL LC02
; 170: Lcdout "Temp:"
	MOVLW 0x54
	CALL LC01
	MOVLW 0x65
	CALL LC01
	MOVLW 0x6D
	CALL LC01
	MOVLW 0x70
	CALL LC01
	MOVLW 0x3A
	CALL LC01
; 171: temp3 = termo
	MOVF 0x1E,W
	MOVWF 0x1C
; 172: Gosub print1
	CALL L0009
; 173: WaitMs 1000 'TO CHANGE !!!!!!!!!!!!!!!!!
	MOVLW 0xE8
	MOVWF R0L
	MOVLW 0x03
	MOVWF R0H
	CALL W001
; 174: Endif
L0035:	MOVLW 0x1F
	ANDWF STATUS,F
; 175: 
; 176: Goto loop4
	GOTO L0006
; 177: Return
	RETURN
; 178: 
; 179: measure: 
L0007:
; 180: DS18S20Start
	CALL WW01
	MOVLW 0xCC
	CALL WW05
	MOVLW 0x44
	CALL WW05
; 181: Gosub time
	CALL L0011
; 182: Gosub time
	CALL L0011
; 183: DS18S20ReadT temp, sign
	CALL WW01
	MOVLW 0xCC
	CALL WW05
	MOVLW 0xBE
	CALL WW05
	CALL WW07
	MOVWF 0x19
	CALL WW07
	MOVWF 0x1B
	CALL WW01
; 184: If sign.7 = 1 Then temp = (255 - temp + 1)
	BTFSS 0x1B,7
	GOTO L0039
;       The address of 'oshonsoft_temp_1' is 0x22
	oshonsoft_temp_1 EQU 0x22
	MOVF 0x19,W
	SUBLW 0xFF
	MOVWF 0x22
	CLRW
	BTFSS STATUS,C
	ADDLW 0x01
	SUBLW 0x00
	MOVWF 0x23
	MOVF 0x22,W
	ADDLW 0x01
	MOVWF 0x22
	MOVF 0x23,W
	BTFSC STATUS,C
	ADDLW 0x01
	ADDLW 0x00
	MOVWF 0x23
	MOVF 0x22,W
	MOVWF 0x19
L0039:	MOVLW 0x1F
	ANDWF STATUS,F
; 185: temp2 = temp / 2
	MOVF 0x19,W
	MOVWF R0L
	CLRF R0H
	MOVLW 0x02
	MOVWF R1L
	CLRF R1H
	CALL D001
	MOVWF 0x1A
; 186: If sign.7 = 1 Then
	BTFSS 0x1B,7
	GOTO L0040
; 187: temp2 = 100 - temp2
	MOVF 0x1A,W
	SUBLW 0x64
	MOVWF 0x1A
; 188: Else
	GOTO L0041
L0040:	MOVLW 0x1F
	ANDWF STATUS,F
; 189: temp2 = temp2 + 100
	MOVF 0x1A,W
	ADDLW 0x64
	MOVWF 0x1A
; 190: Endif
L0041:	MOVLW 0x1F
	ANDWF STATUS,F
; 191: Return
	RETURN
; 192: 
; 193: print: 
L0008:
; 194: If sign.7 = 1 Then Lcdout "-"
	BTFSS 0x1B,7
	GOTO L0042
	MOVLW 0x2D
	CALL LC01
L0042:	MOVLW 0x1F
	ANDWF STATUS,F
; 195: dig = temp.0
	BTFSC 0x19,0
	BSF 0x18,0
	BTFSS 0x19,0
	BCF 0x18,0
; 196: temp3 = temp / 2
	MOVF 0x19,W
	MOVWF R0L
	CLRF R0H
	MOVLW 0x02
	MOVWF R1L
	CLRF R1H
	CALL D001
	MOVWF 0x1C
; 197: Lcdout #temp3
	MOVF 0x1C,W
	MOVWF R2L
	CLRF R2H
	CALL LC21
; 198: If dig = 1 Then
	BTFSS 0x18,0
	GOTO L0043
; 199: Lcdout ".5"
	MOVLW 0x2E
	CALL LC01
	MOVLW 0x35
	CALL LC01
; 200: Else
	GOTO L0044
L0043:	MOVLW 0x1F
	ANDWF STATUS,F
; 201: Lcdout ".0"
	MOVLW 0x2E
	CALL LC01
	MOVLW 0x30
	CALL LC01
; 202: Endif
L0044:	MOVLW 0x1F
	ANDWF STATUS,F
; 203: Return
	RETURN
; 204: 
; 205: print1: 
L0009:
; 206: If temp3 >= 100 Then
	MOVLW 0x64
	SUBWF 0x1C,W
	BTFSS STATUS,C
	GOTO L0045
; 207: temp3 = temp3 - 100
	MOVLW 0x64
	SUBWF 0x1C,W
	MOVWF 0x1C
; 208: Lcdout " "
	MOVLW 0x20
	CALL LC01
; 209: Lcdout #temp3
	MOVF 0x1C,W
	MOVWF R2L
	CLRF R2H
	CALL LC21
; 210: Else
	GOTO L0046
L0045:	MOVLW 0x1F
	ANDWF STATUS,F
; 211: temp3 = 100 - temp3
	MOVF 0x1C,W
	SUBLW 0x64
	MOVWF 0x1C
; 212: Lcdout "-"
	MOVLW 0x2D
	CALL LC01
; 213: Lcdout #temp3
	MOVF 0x1C,W
	MOVWF R2L
	CLRF R2H
	CALL LC21
; 214: Endif
L0046:	MOVLW 0x1F
	ANDWF STATUS,F
; 215: Return
	RETURN
; 216: 
; 217: button: 
L0010:
; 218: TRISA = 1
	BSF STATUS,RP0
	MOVLW 0x01
	MOVWF 0x05
	BCF STATUS,RP0
; 219: TRISB = 255
	BSF STATUS,RP0
	MOVLW 0xFF
	MOVWF 0x06
	BCF STATUS,RP0
; 220: PORTA.2 = 0
	BCF 0x05,2
; 221: temp3 = PORTB
	MOVF 0x06,W
	MOVWF 0x1C
; 222: ASM: comf temp3, 1 'invert **************
	comf temp3, 1
; 223: TRISA = 5
	BSF STATUS,RP0
	MOVLW 0x05
	MOVWF 0x05
	BCF STATUS,RP0
; 224: TRISB = 0
	BSF STATUS,RP0
	CLRF 0x06
	BCF STATUS,RP0
; 225: Return
	RETURN
; 226: 
; 227: time: 
L0011:
; 228: WaitMs 500
	MOVLW 0xF4
	MOVWF R0L
	MOVLW 0x01
	MOVWF R0H
	CALL W001
; 229: Return
	RETURN
; 230: 
; 231: 
; 232: 
; 233: 
; 234: 
; 235: 
; 236: 
; 237: 
; End of program
L0047:	GOTO L0047
; Division Routine
D001:	MOVLW 0x10
	MOVWF R3L
	CLRF R2H
	CLRF R2L
D002:	RLF R0H,W
	RLF R2L,F
	RLF R2H,F
	MOVF R1L,W
	SUBWF R2L,F
	MOVF R1H,W
	BTFSS STATUS,C
	INCFSZ R1H,W
	SUBWF R2H,F
	BTFSC STATUS,C
	GOTO D003
	MOVF R1L,W
	ADDWF R2L,F
	MOVF R1H,W
	BTFSC STATUS,C
	INCFSZ R1H,W
	ADDWF R2H,F
	BCF STATUS,C
D003:	RLF R0L,F
	RLF R0H,F
	DECFSZ R3L,F
	GOTO D002
	MOVF R0L,W
	RETURN
; Waitms Routine
W001:	MOVF R0L,F
	BTFSC STATUS,Z
	GOTO W002
	CALL W003
	DECF R0L,F
	NOP
	NOP
	NOP
	NOP
	NOP
	GOTO W001
W002:	MOVF R0H,F
	BTFSC STATUS,Z
	RETURN
	CALL W003
	DECF R0H,F
	DECF R0L,F
	GOTO W001
W003:	MOVLW 0x0C
	MOVWF R2H
W004:	DECFSZ R2H,F
	GOTO W004
	NOP
	NOP
	MOVLW 0x12
	MOVWF R1L
W005:	DECFSZ R1L,F
	GOTO W006
	CALL W007
	CALL W007
	NOP
	NOP
	RETURN
W006:	CALL W007
	GOTO W005
W007:	MOVLW 0x0D
	MOVWF R2L
W008:	DECFSZ R2L,F
	GOTO W008
	NOP
	RETURN
; Waitus Routine - Byte Argument
X001:	MOVLW 0x0A
	SUBWF R4L,F
	BTFSS STATUS,C
	RETURN
	GOTO X002
X002:	MOVLW 0x06
	SUBWF R4L,F
	BTFSS STATUS,C
	RETURN
	GOTO X002
; Waitus Routine - Word Argument
Y001:	MOVLW 0x10
	SUBWF R4L,F
	CLRW
	BTFSS STATUS,C
	ADDLW 0x01
	SUBWF R4H,F
	BTFSS STATUS,C
	RETURN
	GOTO Y002
Y002:	MOVLW 0x0A
	SUBWF R4L,F
	CLRW
	BTFSS STATUS,C
	ADDLW 0x01
	SUBWF R4H,F
	BTFSS STATUS,C
	RETURN
	GOTO Y002
; Lcdout Routine
LC01:	BSF 0x05,1
	MOVWF 0x06
	BSF 0x05,3
	NOP
	BCF 0x05,3
	MOVLW 0x64
	MOVWF R4L
	CALL X001
	RETURN
; Lcdcmdout Routine
LC02:	BCF 0x05,1
	MOVWF 0x06
	BSF 0x05,3
	NOP
	BCF 0x05,3
	MOVLW 0x88
	MOVWF R4L
	MOVLW 0x13
	MOVWF R4H
	CALL Y001
	RETURN
; Lcdout Decimal Conversion Routine
LC21:	BSF R3H,7
	MOVLW 0x27
	MOVWF R1H
	MOVLW 0x10
	CALL LC22
	MOVLW 0x03
	MOVWF R1H
	MOVLW 0xE8
	CALL LC22
	CLRF R1H
	MOVLW 0x64
	CALL LC22
	CLRF R1H
	MOVLW 0x0A
	CALL LC22
	MOVF R2L,W
	GOTO LC23
LC22:	MOVWF R1L
	MOVF R2H,W
	MOVWF R0H
	MOVF R2L,W
	MOVWF R0L
	CALL D001
	MOVF R0L,W
	BTFSS STATUS,Z
	BCF R3H,7
	BTFSC R3H,7
	RETURN
LC23:	ADDLW 0x30
	CALL LC01
	RETURN
; 1-wire Routine
WW01:	BCF 0x05,0
	MOVLW 0xFF
	MOVWF R4L
	BSF STATUS,RP0
	BCF 0x05,0
	CALL X001
	CALL X001
	BSF 0x05,0
	BCF STATUS,RP0
	MOVLW 0x41
	MOVWF R4L
	CALL X001
	MOVF 0x05,W
	MOVWF R4H
	MOVLW 0xFF
	MOVWF R4L
	CALL X001
	CALL X001
	BTFSC R4H,0
	BSF STATUS,C
	BTFSS R4H,0
	BCF STATUS,C
	RETURN
WW02:	BCF 0x05,0
	BSF STATUS,RP0
	BCF 0x05,0
	NOP
	NOP
	BSF 0x05,0
	BCF STATUS,RP0
	MOVLW 0x0A
	MOVWF R4L
	CALL X001
	MOVF 0x05,W
	MOVWF R4H
	MOVLW 0x41
	MOVWF R4L
	CALL X001
	BTFSC R4H,0
	BSF STATUS,C
	BTFSS R4H,0
	BCF STATUS,C
	RETURN
WW03:	BCF 0x05,0
	BSF STATUS,RP0
	BCF 0x05,0
	BCF STATUS,RP0
	MOVLW 0x02
	MOVWF R4L
	CALL X001
	BSF 0x05,0
	MOVLW 0x41
	MOVWF R4L
	CALL X001
	BSF STATUS,RP0
	BSF 0x05,0
	BCF STATUS,RP0
	MOVLW 0x02
	MOVWF R4L
	CALL X001
	RETURN
WW04:	BCF 0x05,0
	BSF STATUS,RP0
	BCF 0x05,0
	MOVLW 0x43
	MOVWF R4L
	CALL X001
	BSF 0x05,0
	BCF STATUS,RP0
	MOVLW 0x02
	MOVWF R4L
	CALL X001
	RETURN
WW05:	MOVWF R3H
	MOVLW 0x08
	MOVWF R3L
WW06:	BTFSC R3H,0
	CALL WW03
	BTFSS R3H,0
	CALL WW04
	RRF R3H,F
	DECFSZ R3L,F
	GOTO WW06
	RETURN
WW07:	MOVLW 0x08
	MOVWF R3L
WW08:	CALL WW02
	RRF R3H,F
	DECFSZ R3L,F
	GOTO WW08
	MOVF R3H,W
	RETURN
; End of listing
	END
